const { ItemCategory, User } = require("../../models");
const { NO_FILE, SERVER_ERROR } = require("../../utils/errorMessage");
const { STATUS_CODE } = require("../../utils/utility");
const routeHandler = require("../../utils/routeHandler");
const { isNull } = require("../../utils/validation");
const { sendAppError } = require("../../utils/appError");
const { Op, fn, col, literal } = require("sequelize");
const fastcsv = require('fast-csv');
const path = require('path');
const fs = require('fs');

const create = routeHandler(async (req, res, extras, next) => {
    const {
        item_category_name,
        item_category_descp
    } = req.body;

    const { user_id, branch_id } = req.auth;

    const paramNames = ["Item Category Name"];
    const { hasNull, missingParams } = isNull([item_category_name]);
    if (hasNull) {
        const missingParamNames = missingParams.map(index => paramNames[index]);
        return sendAppError(extras, `${missingParamNames.join(', ')} ${missingParamNames.length > 1 ? 'are' : 'is'} required`, STATUS_CODE.BAD_REQUEST);
    }
    try {
        const findItemCategory = await ItemCategory.findOne({
            where: {
                [Op.or]: [
                    { item_category_name }
                ],
            },
        });

        if (findItemCategory) {
            if (findItemCategory.item_category_name === item_category_name) {
                return sendAppError(extras, "Item Category Name already exists", STATUS_CODE.BAD_REQUEST);
            }
        }

        const itemCategory = await ItemCategory.create({
            branch_id,
            item_category_name,
            item_category_descp,
            created_by: user_id
        }, { transaction: extras.transaction });

        await extras.transaction.commit();
        const itemCategoryDetails = await getDetails(itemCategory.item_category_id);
        return res.sendRes(itemCategoryDetails, { message: 'Item Category created successfully', status: STATUS_CODE.OK });
    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, SERVER_ERROR, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
});

const getAll = routeHandler(async (req, res, extras) => {
    const { search, active_status } = req.query;
    const { branch_id } = req.auth;
    let findObj = findObject(search, branch_id, active_status);
    try {
        const itemCategories = await ItemCategory.findAll({
            where: findObj,
            include: [
                {
                    model: User,
                    as: 'user_created',
                    attributes: ['user_id', 'fullname'],
                },
                {
                    model: User,
                    as: 'user_updated',
                    attributes: ['user_id', 'fullname'],
                },
            ],
            order: [['created_at', 'DESC'],],
            ...req.paginate,
        });

        return res.sendRes(itemCategories, {
            message: 'Item categorys loaded successfully',
            ...req.meta,
            total: await ItemCategory.count({
                where: findObj,
            }),
            status: STATUS_CODE.OK,
        });

    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
}, false);

function findObject(search, branch_id, active_status) {
    let findObj = {};

    if (search) {
        findObj[Op.or] = [
            { item_category_name: { [Op.substring]: search } }
        ];
    }

    if (branch_id && branch_id != 'undefined') findObj.branch_id = branch_id;
    if (active_status && active_status != 'undefined') findObj.active_status = active_status;

    return findObj;
}

const getById = routeHandler(async (req, res, extras) => {
    const { item_category_id } = req.params;

    try {
        const itemCategory = await ItemCategory.findOne({
            where: { item_category_id },
        });

        if (!itemCategory) {
            return sendAppError(extras, 'Item Category not found', STATUS_CODE.NOT_FOUND);
        }

        return res.sendRes(itemCategory, { message: 'Item Category loaded successfully', status: STATUS_CODE.OK });
    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
}, false);

const updateById = routeHandler(async (req, res, extras) => {
    const { item_category_id } = req.params;
    const { user_id } = req.auth;
    const { area_id, item_category_name, item_category_descp, changeStatus } = req.body;

    try {
        const itemCategory = await ItemCategory.findOne({
            where: { item_category_id },
        });

        if (!itemCategory) {
            return sendAppError(extras, 'Item Category not found', STATUS_CODE.NOT_FOUND);
        }

        if (changeStatus) {
            const newStatus = itemCategory.active_status === true ? false : true;
            await itemCategory.update({
                active_status: newStatus,
                updated_by: user_id,
            }, { transaction: extras.transaction });

            await extras.transaction.commit();
            const itemCategoryDetails = await getDetails(itemCategory.item_category_id);
            return res.sendRes(itemCategoryDetails, { message: 'Item Category status updated successfully', status: STATUS_CODE.OK });
        }

        if (item_category_name) {
            const findItemCategory = await ItemCategory.findOne({
                where: {
                    item_category_name,
                    branch_id,
                    item_category_id: { [Op.ne]: item_category_id }
                },
                paranoid: false,
            });

            if (findItemCategory) {
                return sendAppError(extras, "Item Category Name already exists", STATUS_CODE.BAD_REQUEST);
            }
        }

        await itemCategory.update({
            item_category_name,
            item_category_descp,
            updated_by: user_id,
        }, { transaction: extras.transaction });

        await extras.transaction.commit();
        const itemCategoryDetails = await getDetails(itemCategory.item_category_id);
        return res.sendRes(itemCategoryDetails, { message: 'Item Category details updated successfully', status: STATUS_CODE.OK });

    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
});

const deleteById = routeHandler(async (req, res, extras) => {
    const { item_category_id } = req.params;

    try {
        const itemCategory = await ItemCategory.findOne({ where: { item_category_id } });
        if (!itemCategory) {
            return sendAppError(extras, 'Item Category not found', STATUS_CODE.NOT_FOUND);
        }

        await itemCategory.update({
            deleted_by: req.auth.user_id,
        }, { transaction: extras.transaction });

        await itemCategory.destroy({ transaction: extras.transaction });
        await extras.transaction.commit();
        return res.sendRes(null, { message: 'Item Category details deleted successfully', status: STATUS_CODE.OK });
    } catch (error) {
        await extras.transaction.rollback();
        return sendAppError(extras, error.message, STATUS_CODE.INTERNAL_SERVER_ERROR);
    }
});

const bulkUpload = routeHandler(async (req, res, extras) => {
    const file = req.file;
    const { user_id, branch_id } = req.auth;

    if (!file) {
        return sendAppError(extras, NO_FILE, STATUS_CODE.BAD_REQUEST);
    }

    const filePath = path.join(__dirname, '../../uploads', file.filename || `${Date.now()}_${file.originalname}`);
    if (file.buffer) {
        fs.writeFileSync(filePath, file.buffer);
    }
    const itemCategoriesData = [];
    const errors = [];
    const stream = fs.createReadStream(filePath);
    try {
        const processingPromises = [];

        await new Promise((resolve, reject) => {
            fastcsv.parseStream(stream, { headers: true })
                .on('data', (row) => {
                    processingPromises.push(
                        (async () => {
                            const { rowRefId, rowItemCategoryName, rowItemCategoryDesc } = row;
                            if (!rowItemCategoryName) {
                                errors.push('Item Category Name Name is required');
                            } else {
                                try {
                                    const existingItemCategory = await ItemCategory.findOne({ where: { item_category_name: rowItemCategoryName } });

                                    if (!existingItemCategory) {
                                        itemCategoriesData.push({
                                            tbl_ref_id: rowRefId,
                                            branch_id: branch_id,
                                            item_category_name: rowItemCategoryName,
                                            item_category_descp: rowItemCategoryDesc,
                                            created_by: user_id
                                        });
                                    }
                                } catch (dbError) {
                                    reject(dbError);
                                }
                            }
                        })()
                    );
                })
                .on('end', async () => {
                    try {
                        await Promise.all(processingPromises);
                        resolve();
                    } catch (err) {
                        reject(err);
                    }
                })
                .on('error', (error) => reject(error));
        });
        if (errors.length > 0) {
            return sendAppError(extras, errors.join(', '), STATUS_CODE.BAD_REQUEST);
        }

        await extras.transaction.begin();
        try {
            const itemCategories = await ItemCategory.bulkCreate(itemCategoriesData, { transaction: extras.transaction });
            await extras.transaction.commit();
            return res.sendRes(itemCategories, { message: 'Item categorys created successfully', status: STATUS_CODE.OK });
        } catch (error) {
            await extras.transaction.rollback();
            return sendAppError(extras, 'Failed to create Landmarks', STATUS_CODE.INTERNAL_SERVER_ERROR);
        }
    } catch (error) {
        return sendAppError(extras, 'Error processing file', STATUS_CODE.INTERNAL_SERVER_ERROR);
    } finally {
        fs.unlinkSync(filePath);
    }
});

async function getDetails(id) {
    return await ItemCategory.findOne({
        where: { item_category_id: id },
        include: [
            {
                model: User,
                as: 'user_created',
                attributes: ['user_id', 'fullname'],
            },
            {
                model: User,
                as: 'user_updated',
                attributes: ['user_id', 'fullname'],
            },
        ],
    });
}

module.exports = {
    create,
    getAll,
    getById,
    updateById,
    deleteById,
    bulkUpload
};
